<template>
    <v-row justify="center">
      <v-btn class="back-button" color="primary" @click="handleBack" small outlined dark >
        <v-icon left>mdi-arrow-left-thick</v-icon>
        Retour
      </v-btn>
        <v-col cols="12" sm="8">
            <v-card class="elevation-12">
                <v-form>
                    <v-card-title>Inviter un nouveau collaborateur</v-card-title>
                    <v-card-text>
                        <v-text-field v-model="email" type="email" placeholder="Son email*" id="email"
                            autocomplete="username" :error-messages="emailErrors" />
                    </v-card-text>
                    <v-card-text>
                        <v-text-field v-model="firstName" type="text" placeholder="Son prénom*" id="Firstname"
                            :error-messages="firstNameErrors" />
                    </v-card-text>
                    <v-card-text>
                        <v-text-field v-model="lastName" type="text" placeholder="Son nom de famille*" id="Lastname"
                            :error-messages="lastNameErrors" />
                    </v-card-text>
                    <v-card-actions>
                        <v-btn color="secondary" light type="submit" @click="handleRegister">
                            S'inscrire
                        </v-btn>
                    </v-card-actions>
                </v-form>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
import { mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';
import { validationMixin } from 'vuelidate';
import { required, email } from 'vuelidate/lib/validators';
import NotificationMixin from '../../../mixins/NotificationMixin';
export default {
  name:'AdminCollaboratorForm',
  mixins: [validationMixin, NotificationMixin],
  validations: {
    lastName: {required},
		firstName: { required },
		email: { required, email }
	},
  data() {
    return {
      email: '',
      firstName: '',
      lastName:'',
      errors: [],
    }
  },
  computed: {
		lastNameErrors () {
			const errors = []
			if (!this.$v.lastName.$dirty) return errors
			!this.$v.lastName.required && errors.push('lastName requis')
			return errors
		},
		firstNameErrors () {
			const errors = []
			if (!this.$v.firstName.$dirty) return errors
			!this.$v.firstName.required && errors.push('firstName requis')
			return errors
		},

		emailErrors () {
			const errors = []
			if (!this.$v.email.$dirty) return errors
			!this.$v.email.email && errors.push('Email non valide')
			!this.$v.email.required && errors.push('Email requis')
			return errors
		},
    ...mapFields('admin', ['company', 'companyFound', 'isLoading']),
    ...mapFields('user', ['error']),
	},
  methods: {
    handleRegister: function (event) {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      let user = {
        email : this.email,
        firstName: this.firstName,
        lastName : this.lastName,
        password : 'notAPassword',
        company: 'companies/' + this.company.id,
        roles:['ROLE_COMPANY']
      }
      this.register(user);
    },
    handleBack() {
      this.$router.push({name:'adminCollaboratorsList'})
    },
    ...mapActions('user', ['register'])
  }, 
  watch: {
    error(newError) {
      if (newError) {
        this.showMessage('Cet email existe déjà', 'error');
      }
    }
  },
}
</script>

<style>
  .back-button {
    position: absolute;
    left: 10px;
    top: 0;
  }
</style>